=== debian/changelog ===
llvm-toolchain-snapshot (1:18~++20231211102647+75193b192ad9-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * Set the cpu defaults for the ARM32 architectures:
    - armel: arm926ej-s. Addresses: #1056115.
    - armhf: cortex-a8.
    Thanks to Arnd Bergmann and Ard Biesheuvel for the fixes.
  * Apply the proposed fix for D158491, build failure on mips64el, still
    unreviewed upstream. Addresses: #1056116.

  [ Sylvestre Ledru ]
  * New snapshot release
  * Fix a libc++ conflicts (Closes: #1057899)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 11 Dec 2023 10:26:59 +0100

llvm-toolchain-17 (1:17.0.6-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Add new cmake-clang-test to spot issues such as
    Debian bug #1057151
  * Fix cmake file (Closes: #1057151)
  * Drop sed command, useless now

  [ Matthias Klose ]
  * Also use the free swap to determine the number of parallel processes.
  * libclang1-17: Hard-code the last full versions for the symlinks.
  * Also use the free swap to determine the number of parallel processes.
  * Set the cpu defaults for the ARM32 architectures:
    - armel: arm926ej-s. Closes: #1056115.
    - armhf: cortex-a8.
    Thanks to Arnd Bergmann and Ard Biesheuvel for the fixes.
  * Apply the proposed fix for D158491, build failure on mips64el, still
    unreviewed upstream. Addresses: #1056116.

  [ Sylvestre Ledru ]
  * Move the symlink /usr/lib/*/libc++experimental.a from libc++abi-17-dev
    to libc++-17-dev
  * Remove some old break/replaces from 16
  * Fix the EmitBackendOutput test in debian/qualify-clang.sh
  * Also add back /usr/lib/llvm-17/lib/libclang-17.so.1

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Dec 2023 09:49:04 +0100

llvm-toolchain-17 (1:17.0.6-1) unstable; urgency=medium

  [ Matthias Klose ]
  * Further limit the number of parallel processes
  * Don't build-depend on llvm-spirv-17 on armel and mipsel (LLVM 17 is not
    yet built on these architectures).
  * Fix stripping build flags on Ubuntu/ppc64el.
  * libclang1-17: Only encode the major version in the soname. Closes: #1056126.
  * libclang1-17: Provide a symlink for the last soname with the full version.
  * Restore the patch for D148945, searching /usr/lib/llvm-17/lib by default.
    Closes: #1056580.

  [ Sylvestre Ledru ]
  * New upstream release
  * Add a symlink for libc++experimental.a to /usr/lib/*/libc++experimental.a
    to fix https://github.com/llvm/llvm-project/issues/72753
  * try to relax the wasi-libc dep declaration for apt.llvm.org
  * add a check that, if we are going to build wasm, wasi-libc is installed
    on the system

  [ John Paul Adrian Glaubitz ]
  * Don't install *clang_rt* on sparc and sparc64

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 28 Nov 2023 11:43:43 +0100
